"use strict";

try {
  Object.assign(exports, require("chcp"));
} catch (ex) {
  fallback();
}

function fallback() {
  var path = require("path");

  var chcpCom = path.join(process.env.windir || process.env.SystemRoot || "C:/Windows", "System32/chcp.com");
  ;

  var childProcess = require("child_process");

  var cache;

  function getConsoleCodePage() {
    if (!cache) {
      cache = childProcess.spawnSync(chcpCom, {
        env: {},
        encoding: "ascii"
      }).stdout;
      cache = +/\d+\s*$/.exec(cache)[0];
    }

    return cache;
  }

  exports.getConsoleCodePage = getConsoleCodePage;
}