"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var osArch = require("git-win/lib/os-arch");

var path = require("path");

var spawn = require("./spawn");

var getEnvValue = require("./get-env-value");

var regExe = path.join(getEnvValue("SystemRoot"), "System32/reg.exe"); // const fs = require('fs-extra');
// const Path = require('Path');

function parseValue(type, value) {
  switch (type) {
    case "REG_DWORD":
      {
        return parseInt(value);
      }

    case "REG_BINARY":
      {
        return binToUint8Array(value);
      }
    // case "REG_QWORD": {
    // 	return hexToUint8Array(value);
    // }
  }

  return value;
} // function hexToUint8Array (hex) {
// 	const prefix = hex.slice(0, 2);
// 	hex = hex.slice(2);
// 	if ((hex.length % 2) !== 0) {
// 		hex = "0" + hex;
// 	}
// 	const view = new Uint8Array(hex.length / 2);
// 	for (let i = 0; i < hex.length; i += 2) {
// 		view[i / 2] = parseInt(prefix + hex.slice(i, i + 2));
// 	}
// 	return view;
// }


function binToUint8Array(bin) {
  var view = new Uint8Array(bin.length / 2);

  for (var i = 0; i < bin.length; i += 2) {
    view[i / 2] = parseInt(bin.slice(i, i + 2), 16);
  }

  return view;
} // function strToHex (value) {
// 	if (!value) {
// 		return '-';
// 	}
// 	if (value.includes(';')) {
// 		return 'hex(2):' + Array.from(value).map(char => (
// 			Number(char.charCodeAt(0)).toString(16)
// 		)).join(',');
// 	} else {
// 		return JSON.stringify(value);
// 	}
// }


function add(_x, _x2) {
  return _add.apply(this, arguments);
}

function _add() {
  _add = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(key, values) {
    var oldValues;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            key = path.win32.normalize(key);
            _context.next = 3;
            return query(key);

          case 3:
            oldValues = _context.sent;
            _context.next = 6;
            return Promise.all(Object.keys(values).map(function (valueName) {
              if (values[valueName] === oldValues[valueName]) {
                return;
              }

              if (values[valueName] == null) {
                return regDelete(key, valueName);
              }

              return spawn([regExe, "ADD", key, "/v", valueName, "/t", Number.isFinite(values[valueName]) ? "REG_DWORD" : "REG_EXPAND_SZ", "/d", values[valueName], "/f", "/reg:" + osArch], {
                argv0: "reg",
                stdio: "inherit",
                echo: true
              });
            }));

          case 6:
            delete reqCache[key];

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _add.apply(this, arguments);
}

var reqCache = {};

function queryAsync(_x3) {
  return _queryAsync.apply(this, arguments);
}

function _queryAsync() {
  _queryAsync = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(key) {
    var result, stdout, prefix, currKey;
    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            result = {};
            _context2.next = 3;
            return spawn([regExe, "QUERY", key, "/s", "/reg:" + osArch], {
              argv0: "reg",
              encoding: "utf8"
            });

          case 3:
            stdout = _context2.sent;
            currKey = result;
            stdout.split(/[\r\n]+/g).forEach(function (line) {
              if (line.startsWith("HKEY_")) {
                if (prefix == null) {
                  prefix = "";
                  key = line.slice(0, line.indexOf("\\") + key.replace(/^\w+/, "").length);
                }

                prefix = line.slice(key.length + 1);
                currKey = result;
                prefix.split(/\\/g).filter(Boolean).forEach(function (key) {
                  if (!currKey[key]) {
                    currKey[key] = {};
                  }

                  currKey = currKey[key];
                });
              } else if (/^\s+(.*?)\s+(REG_[A-Z_]+)\s+(.*?)$/.test(line)) {
                var _key = RegExp.$1,
                    type = RegExp.$2,
                    value = RegExp.$3;
                currKey[_key] = parseValue(type, value);
              }
            });
            return _context2.abrupt("return", result);

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));
  return _queryAsync.apply(this, arguments);
}

function query(key) {
  key = path.win32.normalize(key);

  if (reqCache[key]) {
    return reqCache[key];
  }

  reqCache[key] = queryAsync(key);
  return reqCache[key];
}

function regDelete(_x4, _x5) {
  return _regDelete.apply(this, arguments);
}

function _regDelete() {
  _regDelete = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3(key, valueName) {
    var oldValues;
    return _regenerator.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            key = path.win32.normalize(key);
            _context3.next = 3;
            return query(key);

          case 3:
            oldValues = _context3.sent;

            if (oldValues[valueName]) {
              _context3.next = 6;
              break;
            }

            return _context3.abrupt("return");

          case 6:
            delete reqCache[key];
            return _context3.abrupt("return", spawn([regExe, "DELETE", key, "/v", valueName, "/f", "/reg:" + osArch], {
              argv0: "reg",
              stdio: "inherit",
              echo: true
            }));

          case 8:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));
  return _regDelete.apply(this, arguments);
}

module.exports = {
  add,
  query,
  delete: regDelete
};